/*
    Andrei Baltatu
    Solutie O(K)
*/

#include <bits/stdc++.h>
#define int long long
using namespace std;

struct point_wall
{
    int pos, val;
    point_wall(int _pos, int _val)
    {
        pos = _pos;
        val = _val;
    }
};

int n, k, t;
vector<point_wall> restr;

vector<point_wall> Normalize(vector<point_wall> A)
{
    vector<point_wall> res(A.begin(), A.end());

    // from left
    point_wall mn = A.front();
    for (int i = 0; i < A.size(); i++)
    {
        // check if present element is a better restriction
        if (1LL * t * abs(A[i].pos - mn.pos) + mn.val > A[i].val)
            mn = A[i];

        // change element on this position in result
        res[i].val = min(res[i].val, 1LL * t * abs(res[i].pos - mn.pos) + mn.val);
    }

    // from right
    mn = A.back();
    for (int i = A.size() - 1; i >= 0; i--)
    {
        // check if present element is a better restriction
        if (1LL * t * abs(A[i].pos - mn.pos) + mn.val > A[i].val)
            mn = A[i];

        // change element on this position in result
        res[i].val = min(res[i].val, 1LL * t * abs(res[i].pos - mn.pos) + mn.val);
    }

    return res;
}

int Local_maxima(point_wall x, point_wall y)
{
    int mx = max(x.val, y. val);

    // now look between the walls
    if (y.val < x.val) swap(x, y);

    int dif = abs(y.pos - x.pos) - 1;
    int steps = (y.val - x.val) / t;

    if (!dif || dif < steps) return mx;

    dif -= steps;
    x.val += 1LL * steps * t;

    if (!dif) return mx;
    if (dif & 1) // odd
    {
        int length = (dif / 2) + 1;
        mx = max(mx, x.val + 1LL * length * t);
    }
    else
    {
        int length = dif / 2;
        mx = max(mx, y.val + 1LL * length * t);
    }

    return mx;
}

int32_t main()
{
    freopen("plaja.in", "r", stdin);
    freopen("plaja.out", "w", stdout);
    cin.sync_with_stdio(false);

    cin >> n >> k >> t;
    for (int i = 1; i <= k; i++)
    {
        int x, y;
        cin >> x >> y;
        restr.push_back(point_wall(x, y));
    }

    if (restr.back().pos < n)
        restr.push_back(point_wall(n, 1LL * n * t + (1 << 30)));

    if (restr.front().pos > 1)
        restr.insert(restr.begin(), point_wall(1, 1LL * n * t + (1 << 30)));

    restr = Normalize(restr);


    int mx = 0;
    for (int i = 0; i < restr.size() - 1; i++)
        mx = max(mx, Local_maxima(restr[i], restr[i + 1]));

    cout << mx << "\n";
    return 0;
}
