// O(n * log n * log T)
#include <fstream>
#include <vector>
#include <algorithm>
#include <iostream>
using namespace std;

ifstream fin("plaja.in");
ofstream fout("plaja.out");

struct Entry {
	int day, sgn;
	bool operator < (const Entry& e) const
	{
		return day < e.day || ( day == e.day && sgn > e.sgn);
	}
};

int N, K, T;
vector<long long> d, t;

bool Try(long long H);

int main()
{
	fin >> N >> K >> T;
	int day, time;
	for (int i = 0; i < K; ++i)
	{
		fin >> day >> time;
		d.push_back(day);
		t.push_back(time);
	}

	long long l = 0, r = (1LL << 35), m;
    long long res = 0;

    while (l <= r)
    {
        m = (l + r) / 2;
        if (Try(m))
        {
            res = m;
            l = m + 1;
		}
        else
            r = m - 1;
    }

	fout << res;
}

bool Try(long long t0)
{
    vector <Entry> e;
    e.push_back( {1, 0} );
    e.push_back({N + 1, -1});
    int a, b;
    for (int i = 0; i < K; i++)
        if (t[i] < t0)
        {
            long long x = (t0 - t[i] - 1) / T;
            a = max(d[i] - x, 1LL);
            b = min(d[i] + x + 1, (long long)(N + 1));

            e.push_back({a, 1});
            e.push_back({b, -1});
        }

    sort(e.begin(), e.end());

    long long cnt = 0;
    for (int i = 0; i < e.size(); i++)
    {
        cnt += e[i].sgn;
        if (cnt <= 0 && e[i].day <= N)
            return true;
    }

    return false;
}

