/*
    prof. Constantin Galatan
    solutie  O(N * log T)
*/
#include <fstream>
#include <vector>
#include <algorithm>
#include <iostream>
using namespace std;

ifstream fin("plaja.in");
ofstream fout("plaja.out");

int N, K, T;
vector<long long> d, t;

bool Try(long long H);

int main()
{
	fin >> N >> K >> T;
	int day, time;
	for (int i = 0; i < K; ++i)
	{
		fin >> day >> time;
		d.push_back(day);
		t.push_back(time);
	}

	long long l = 0, r = (1LL * N * T), m;
    long long res = 0;

    while (l <= r)
    {
        m = (l + r) / 2;
        if (Try(m))
        {
            res = m;
            l = m + 1;
		}
        else
            r = m - 1;
    }

	fout << res;
}

bool Try(long long t0)
{
    vector <int> e(N + 2);
    e[1] = 0;
    e[N + 1] = -1;
    int a, b;
    for (int i = 0; i < K; i++)
        if (t[i] < t0)
        {
            long long x = (t0 - t[i] - 1) / T;
            a = max(d[i] - x, 1LL);
            b = min(d[i] + x + 1, (long long)(N + 1));

            e[a]++;
            e[b]--;
        }
    long long cnt = 0;
    for (int i = 1; i <= N; i++)
    {
        cnt += e[i];
        if (cnt <= 0)
            return true;
    }
    return false;
}

